# Auto_Ptr.h File Reference

`#include "ace/config-all.h"`
`#include "ace/Auto_Ptr.inl"`
`#include "ace/Auto_Ptr.cpp"`

Include dependency graph for Auto_Ptr.h:

This graph shows which files directly or indirectly include this file:

## Classes

class | ACE_Auto_Basic_Ptr< X >
| Implements the draft C++ standard auto_ptr abstraction. This class allows one to work on non-object (basic) types. More...
class | auto_ptr< X >
| Implements the draft C++ standard auto_ptr abstraction. More...
class | ACE_Auto_Ptr< X >
| Implements the draft C++ standard auto_ptr abstraction. This version can be used instead of auto_ptr<T>, and obviates the need for the ACE_AUTO_PTR_RESET macro on platforms like VC6 where the auto_ptr<T> is broken. More...
class | ACE_Auto_Basic_Array_Ptr< X >
| Implements an extension to the draft C++ standard auto_ptr abstraction. This class allows one to work on non-object (basic) types that must be treated as an array, e.g., deallocated via "delete [] foo". More...
class | ACE_Auto_Array_Ptr< X >
| Implements an extension to the draft C++ standard auto_ptr abstraction. More...

## Defines

#define | ACE_AUTO_PTR_RESET(AUTOPTR, NEWPTR, TYPE)

## Detailed Description

Id
  Auto_Ptr.h,v 4.41 2006/01/11 19:54:41 ossama Exp

Author:
  Doug Schmidt <schmidt@uci.edu>

  Irfan Pyarali <irfan@cs.wustl.edu>

  Jack Reeves <jack@fx.com>

  Dr. Harald M. Mueller <mueller@garwein.hai.siemens.co.at>

## Define Documentation

#define ACE_AUTO_PTR_RESET | ( | AUTOPTR,
|  | NEWPTR,
|  | TYPE |  | ) |

Value:

    do { \
             AUTOPTR.reset (NEWPTR); \
          } while (0)